<template>
  <div class="upload_picture">
    <v-file-input
      v-model="picture"
      accept="image/*"
      label="Select your picture"
      show-size
      :rules="[rules.maxSize]"
    />
    <v-select
      :items="picturePrivacyOptions"
      label="Privacy"
      v-model="picturePrivacy"
      class="upload_picture__privacy"
    />
    <FriendsPool v-if="picturePrivacy === picturePrivacyOptions[2]" />
    <v-text-field
      v-model="comment"
      :rules="[rules.commentMaxLen]"
      label="Comment"
      counter
      maxlength="300"
    />
    <v-btn
      class="dark-btn"
      height="50"
      @click="UploadPicture"
      :disabled="disabled"
      style="margin-top: 10px;">
      Upload picture
    </v-btn>
  </div>
</template>

<script>
import { UpdatePictureOptions, UploadPicture } from "@/api/pictures"
import FriendsPool from '@/components/FriendsPool'
import { mapGetters, mapMutations } from 'vuex'

export default {
  name: 'UploadPicture',

  components: {
    FriendsPool
  },

  data: () => ({
    rules: {
      maxSize: value => !value || value.size < 15 * 1000 * 1000 || 'Picture size should be less than 15 MB!',
      commentMaxLen: value => value.length <= 300 || 'Max 300 characters'
    },

    picture: null,
    picturePrivacy: 'Public',
    comment: '',

    disabled: false
  }),

  computed: {
    ...mapGetters([
      'picturePrivacyOptions',
      'usersSharedWith'
    ])
  },

  methods: {
    ...mapMutations([
      'updateUsersSharedWith'
    ]),

    async UploadPicture() {
      if (!this.picture) {
        return
      }

      this.disabled = true

      try {
        const bodyFormData = new FormData()
        bodyFormData.append('picture', this.picture)

        const response = await UploadPicture(bodyFormData)
        if (!response.status) {
          return
        }

        if (response.status !== 200) {
          this.$toasted.error('Oh no... Something bad happened')
          return
        }

        const status = await UpdatePictureOptions(response.data.data.data.id, {
          privacy: this.picturePrivacyOptions.indexOf(this.picturePrivacy),
          sharedWith: this.usersSharedWith,
          comment: this.comment
        })

        if (status === 200) {
          this.$toasted.success("Successfully uploaded")
          this.picture = null
          this.picturePrivacy = this.picturePrivacyOptions[0]
          this.updateUsersSharedWith([])
          return
        }

        this.$toasted.error('Oh no... Something bad happened')
      } finally {
        this.disabled = false
      }
    }
  }
}
</script>

<style>
.upload_picture {
  display: grid;
  place-content: center;
  margin-top: 200px;
}

.v-select__selections input {
  width: 0 !important;
}

</style>
